/* Copyright (C) Sami Ojanen 2008 */
import javax.microedition.rms.RecordStore;
import java.util.Vector;
import javax.microedition.lcdui.Graphics;
import ral.Real;
/*
Associativity
Numbers
() [] -> .
x^y, xsqrty
! ~++ --
* / %
+ -
<< >>
< <= > >=
== !=
&
^
|
&&
||
?:
*/
public abstract class Calc extends Object {

	protected Calc nextCalc;

	public abstract Calc getNewObject();

	public Calc delete(Calc cursor) {
		Calc idx=this;
		if(cursor==null) return null;
		while((idx.nextCalc!=cursor)&&(idx.nextCalc!=null)) 
			idx=idx.nextCalc;
		if(idx.nextCalc!=null) {
			idx.nextCalc=cursor.nextCalc;
			return idx;
		}
		return null;
	}

	public Calc nextCalc() {
		return nextCalc;
	}

	public Calc addNextCalc(Calc cursor) {
		//System.out.println("Calc.addNextCalc(cursor)");
		Calc newCalc=this.getNewObject();
		newCalc.nextCalc=cursor.nextCalc;
		cursor.nextCalc=newCalc;
		return newCalc;
	}

	public Calc addFirstCalc(Calc oldroot) {
		//System.out.println("Calc:addFirstCalc");
		Calc newCalc = this.getNewObject();
		newCalc.nextCalc=oldroot;
		return newCalc;
	}

	public void draw(Graphics g, int x,int y) {
		g.drawString(this.toString(),x,y,Graphics.TOP|Graphics.LEFT);
	}

	public int getWidth(Graphics g) {
		return g.getFont().stringWidth(this.toString());
	}

	public int getHeight(Graphics g) {
		return g.getFont().getHeight();
	}

	public abstract int getEvalPriority();

	public abstract int numOfParameters();

	public abstract Real eval(Vector parameters); // Vectors type is Real
}

