/* Copyright (C) Sami Ojanen 2008 */
import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Font;
import java.util.Vector;
import java.util.Calendar;
import ral.Real;

public class JACanvas extends Canvas {
    private Command exitCommand;
    private Command settingsCommand;
    private final String tablenumbers="123456789.";

	Font font;
	Vector tablelist=null;
	Calc calculations=null;
	Calc table[] = new Calc[12];
	Calc cursor=null;
	Calc error=null;
	Real lastResult=null;
	Calc openParenthese=null;
	Calc closeParenthese=null;
	Calc plusminus=null;
	Calc calcmul,calcdiv,calcsub,calcadd;
	Calc calcn=null;
	Calc calcmode=null;
	CalcAttrAndFnc xcalc = null;
	CalcAttrAndFnc ycalc = null;
	CalcAttrAndFnc zcalc = null;
	CalcAttrAndFnc fxcalc = null;
	CalcAttrAndFnc fxycalc = null;
	CalcAttrAndFnc gxcalc = null;
	Vector vfgx = new Vector();
	boolean simplemode=true;
	String firstbutton,firebutton,thirdbutton;
	CommandListener commandlistener;
	int keycode=0;
	String errstr="";
	boolean prevcALL = false;
// stat-attributes
	public boolean statmode=false;
	Real statavg=new Real(0);
	Real statvar=new Real(0);
	Real statn=new Real(0);
	Real statx2=new Real(0);
	Real statsum=new Real(0);
	Real statsum2=new Real(0);
	Real r= new Real(0);
	boolean plotfxcalc=false;
	//boolean plotfxycalc=false;
	boolean plotgxcalc=false;
	Real plotX1 = new Real(0);
	Real plotX2 = new Real(0);
	Real plotY1 = new Real(0);
	Real plotY2 = new Real(0);
	Real r2 = new Real(0);
	Real r3 = new Real(0);
	Real r4 = new Real(0);
	Real r5 = new Real(0);
	Real rwidth = new Real(0);
	Real rheight = new Real(0);


	public JACanvas(Command extCommand,Command settngsCommand,CommandListener command) {
		exitCommand = extCommand;
		commandlistener=command;
		settingsCommand = settngsCommand;
		tablelist=new Vector();
		table[0]=new CalcParenthese('(');
		openParenthese=table[0];
		table[1]=new CalcParenthese(')');
		closeParenthese=table[1];
		table[2]=new CalcBiOperator("nroot");
		table[3]=new CalcBiOperator("+");
		table[4]=new CalcBiOperator("-");
		table[5]=new CalcBiOperator("^");
		table[6]=new CalcBiOperator("x");
		table[7]=new CalcBiOperator("/");
		table[8]=new CalcBiOperator("mod");
		table[9]=new CalcMode("C/all");
		table[10]=new CalcMode("avg");
		table[11]=new CalcMode("haj.");
		tablelist.insertElementAt(table,tablelist.size());
		calcadd=table[3];
		calcsub=table[4];
		calcmul=table[6];
		calcdiv=table[7];


		table=new Calc[12];
		table[0]=new CalcMonoOperator("sin");
		table[1]=new CalcMonoOperator("cos");
		table[2]=new CalcMonoOperator("tan");
		table[3]=new CalcMonoOperator("asin");
		table[4]=new CalcMonoOperator("acos");
		table[5]=new CalcMonoOperator("atan");
		table[6]=new CalcMonoOperator("sinh");
		table[7]=new CalcMonoOperator("cosh");
		table[8]=new CalcMonoOperator("tanh");
		table[9]=new CalcMonoOperator("asinh");
		table[10]=new CalcMonoOperator("acosh");
		table[11]=new CalcMonoOperator("atanh");
		tablelist.insertElementAt(table,tablelist.size());

		table= new Calc[12];

		table[0]=new CalcMonoOperator("1/");
		table[1]=new CalcMonoOperator("^2");
		table[2]=new CalcMonoOperator("sqrt");
		table[3]=new CalcMonoOperator("e^");
		table[4]=new CalcMonoOperator("10^");
		table[5]=new CalcMonoOperator("2^");
		table[6]=new CalcMonoOperator("ln");
		table[7]=new CalcMonoOperator("lg");
		table[8]=new CalcMonoOperator("l2g");
		table[9]=new CalcMode("sum");
		calcn=new CalcMode("n");
		calcmode=new CalcMode("mode");
		table[10]=calcmode;

		table[11]=new CalcMode("attrb");

		tablelist.insertElementAt(table,tablelist.size());

// teeppäs seuraavaksi atttribuuteille omat calcit
		table= new Calc[12];
		table[0]=new CalcMode("stofX");
		table[1]=new CalcMode("stofXY");
		table[2]=new CalcMode("stogX");
		table[3]=new CalcAttrAndFnc("fX",null,1);
		table[4]=new CalcAttrAndFnc("fXY",null,2);
		table[5]=new CalcAttrAndFnc("gX",null,1);
		table[6]=new CalcMode("stoX");
		table[7]=new CalcMode("stoY");
		table[8]=new CalcMode("stoZ");
		table[9]=new CalcAttrAndFnc(0l,"X");
		table[10]=new CalcAttrAndFnc(0l,"Y");
		table[11]=new CalcAttrAndFnc(0l,"Z");
		tablelist.insertElementAt(table,tablelist.size());
		xcalc = (CalcAttrAndFnc)(table[9]);
		ycalc = (CalcAttrAndFnc)(table[10]);
		zcalc = (CalcAttrAndFnc)(table[11]);
		fxcalc = (CalcAttrAndFnc)(table[3]);
		fxycalc = (CalcAttrAndFnc)(table[4]);
		gxcalc = (CalcAttrAndFnc)(table[5]);

		table= new Calc[12];
		for(int i=0;i<10;i++) table[i]=new CalcNumber((long)(i+1),tablenumbers.substring(i,i+1));
		table[10]=new CalcNumber(0,"0");
		plusminus=new CalcNumber(-1l,"+/-");
		table[11]=openParenthese;
		tablelist.insertElementAt(table,0);
		firstbutton="fnkmode";
		firebutton="=";
		thirdbutton=")";
	}

     public void commandAction(Command c, Displayable d) {
        // Place your code here.
   	if(c == settingsCommand) {
	    ;
	}	
     }

	public void purgestat() {
		statmode=true;
		statavg.assign(0);
		statvar.assign(0);
		statn.assign(0);
		statx2.assign(0);
		statsum.assign(0);
		statsum2.assign(0);
		r.assign(0);
		repaint();
	}

	int getPlotY(Real y,int clipheight) {
		Real r2 = new Real(0);
		Real rwidth = new Real(0);
		rwidth.assign(plotY1);
		rwidth.sub(plotY2);
		rwidth.div(clipheight);
		r2.assign(y);
		r2.sub(plotY2);
		r2.div(rwidth);
		return r2.toInteger();
	}

	int getPlotX(Real x,int clipwidth) {
		Real r2 = new Real(0);
		Real rheight = new Real(0);

		rheight.assign(plotX2);
		rheight.sub(plotX1);
		rheight.div(clipwidth);
		r2.assign(x);
		r2.sub(plotX1);
		r2.div(rheight);
		return r2.toInteger();
	}

	void plotfncx(CalcAttrAndFnc fxcalc,Graphics g) {
		int x;
		if(fxcalc!=null) if(fxcalc.getFunc()!=null) {
			//System.out.println("Tulostaa fxcalcin");
			r.assign(plotX2);
			r.sub(plotX1);
			r.div(g.getClipWidth());
			r5.assign(plotX1);
			vfgx=new Vector();
			r2.assign(r5);
			vfgx.insertElementAt((Object)(r2),0);
			r3=fxcalc.eval(vfgx);
			x=g.getClipX();
			while(r5.lessThan(plotX2)) {
				r4.assign(r3);
				r2.assign(r5);
				r3=fxcalc.eval(vfgx);
				//System.out.println("r3="+r3.toString());
				if(r3.lessThan(plotY2)&&plotY1.lessThan(r3)) {
					g.drawLine(x-1,getPlotY(r4,g.getClipHeight()),x,getPlotY(r3,g.getClipHeight()));
				}
				r5.add(r);
				x++;
			}
		}
	}
/*
	void plotfncxytozero(CalcAttrAndFnc fxcalc, Graphics g) {
		int x;
		int y;
		boolean b;
		Real ry = new Real(0);
		Real ry2 = new Real(0);
		Real ry3 = new Real(0);
		Real ry4 = new Real(0);
		Real ry5 = new Real(0);
		boolean bFirstround=true;
		boolean bo[];
		if(fxcalc!=null) if(fxcalc.getFunc()!=null) {
			bo=new boolean[g.getClipWidth()+1];
			//System.out.println("Tulostaa fxycalcin");
			r.assign(plotX2);
			r.sub(plotX1);
			r.div(g.getClipWidth());
			vfgx=new Vector();
			r2.assign(r5);
			vfgx.insertElementAt((Object)(r2),0);
			
			ry.assign(plotY2);
			ry.sub(plotY1);
			ry.div(g.getClipHeight());
			ry5.assign(plotY1);

			ry2.assign(ry5);
			vfgx.insertElementAt((Object)(ry2),1);
			y=g.getClipY();
			while (ry5.lessThan(plotY2)) {
				x=g.getClipX();
				r5.assign(plotX1);
				r2.assign(r5);
				ry2.assign(ry5);
				b=fxcalc.eval(vfgx).lessThan(Real.ZERO);
				while(r5.lessThan(plotX2)) {
					r4.assign(r3);
					r2.assign(r5);
					ry2.assign(ry5);
					if(fxcalc.eval(vfgx).lessThan(Real.ZERO)!=b) {
						b=(b==false);
						g.drawRect(x,y,1,1);
					} 
					if(!bFirstround) {
						if(b!=bo[x]) g.drawRect(x,y,1,1);
					}
					bo[x]=b;
					x++;
					r5.add(r);
				}
				y++;
				ry5.add(ry);
				bFirstround=false;
			}
		}
	}
/**/
	protected void paint(Graphics g) {
		int yh=0;
		int xw=0;
		int x=0;
		int y=0;
		Calc idx;
	    //synchronized (this) 
	/*	
	    }*/
		if(plotfxcalc||/*plotfxycalc||/**/plotgxcalc) {
			r.assign(7);
			r.div(2);
			if(plotX1.equalTo(plotX2)) {
				if(plotY1.equalTo(plotY2)) {
					if(g.getClipWidth()>g.getClipHeight()) {
						plotY1.sub(r);
						plotY2.add(r);
						r.mul(g.getClipWidth());
						r.div(g.getClipHeight());
						plotX1.sub(r);
						plotX2.add(r);
					} else {
						plotX1.sub(r);
						plotX2.add(r);
						r.mul(g.getClipHeight());
						r.div(g.getClipWidth());
						plotY1.sub(r);
						plotY2.add(r);
					}
				} else {
					plotX1.sub(r);
					plotX2.add(r);
				}
			} else if(plotY1.equalTo(plotY2)) {
					plotY1.sub(r);
					plotY2.add(r);
			}
			if(plotY2.lessThan(plotY1)) plotY2.swap(plotY1);
			if(plotX2.lessThan(plotX1)) plotX2.swap(plotX1);
			g.setColor(0xffffff);
			g.fillRect(g.getClipX(),g.getClipY(),g.getClipWidth(),g.getClipHeight());
			g.setColor(0);
			g.drawString("("+plotX2.toString()+","+plotY2.toString()+")", g.getClipX()+g.getClipWidth(),g.getClipY(),Graphics.TOP|Graphics.RIGHT);
			g.drawString("("+plotX1.toString()+","+plotY1.toString()+")",g.getClipX(),g.getClipY()+g.getClipHeight(),Graphics.BOTTOM|Graphics.LEFT);
			//if(plotX1.toLong()rheight
			if(Real.ZERO.lessThan(plotX2)&&plotX1.lessThan(Real.ZERO)) {
				//System.out.println("nollalöytyi");
				rwidth.assign(plotX2);
				rwidth.sub(plotX1);
				r.assign(rwidth);
				//System.out.println("r="+r.toString());
				rwidth.div(g.getClipWidth());
				r2.assign(Real.ZERO);
				r2.sub(plotX1);
				r2.div(rwidth);
				x=r2.toInteger();
				g.drawLine(g.getClipX()+x,g.getClipY(),g.getClipX()+x,g.getClipY()+g.getClipHeight());
				g.drawLine(g.getClipX()+x,g.getClipY(),g.getClipX()+x-2,g.getClipY()+2);
				g.drawLine(g.getClipX()+x,g.getClipY(),g.getClipX()+x+2,g.getClipY()+2);
				rheight.assign(plotY2);
				rheight.sub(plotY1);
				r.assign(rheight);
				r.div(2);  // 20 bars maximum, I hope so.
				r.ln();
				r2.assign(10);
				r2.ln();
				r.div(r2);
				//System.out.println("R="+r.toString());
				r.floor();
				//System.out.println("10^"+r.toString());
				r2=new Real(10);
				r2.ln();
				r.mul(r2);
				r.exp();
				//System.out.println("10^="+r.toString());
				r2.assign(plotY1);
				r2.div(r);
				r2.floor();
				r2.mul(r);
				r3.assign(r);
				r3.mul(10);
				r4.assign(plotY1);
				r4.div(r3);
				r4.floor();
				r4.mul(r3);
				//System.out.println("r2= nearest Y1"+r2.toString());
				while (r2.lessThan(plotY2)) {
					r2.add(r);
					y=g.getClipY()+getPlotY(r2,g.getClipHeight());
					while(r4.lessThan(r2)) r4.add(r3);
					if(r2.equalTo(r4)) xw=3;
					else xw=1;
					g.drawLine(g.getClipX()+x-xw,y,g.getClipX()+x+xw,y);
				}
			}
			if(Real.ZERO.lessThan(plotY2)&&plotY1.lessThan(Real.ZERO)) {
				//System.out.println("nollalöytyi");
				rwidth.assign(plotY1);
				rwidth.sub(plotY2);
				rwidth.div(g.getClipHeight());
				r2.assign(Real.ZERO);
				r2.sub(plotY2);
				r2.div(rwidth);
				y=r2.toInteger();
				g.drawLine(g.getClipX(),y+g.getClipY(),g.getClipX()+g.getClipWidth(),y+g.getClipY());			
				g.drawLine(g.getClipX()+g.getClipWidth()-2,y+g.getClipY()+2,g.getClipX()+g.getClipWidth(),y+g.getClipY());
				g.drawLine(g.getClipX()+g.getClipWidth()-2,y+g.getClipY()-2,g.getClipX()+g.getClipWidth(),y+g.getClipY());


				rwidth.assign(plotX2);
				rwidth.sub(plotX1);
				r.assign(rwidth);
				r.div(2);  // 20 bars maximum, I hope so.
				r.ln();
				r2.assign(10);
				r2.ln();
				r.div(r2);
				//System.out.println("R="+r.toString());
				r.floor();
				//System.out.println("10^"+r.toString());
				r2=new Real(10);
				r2.ln();
				r.mul(r2);
				r.exp();
				//System.out.println("10^="+r.toString());
				r2.assign(plotX1);
				r2.div(r);
				r2.floor();
				r2.mul(r);
				r3.assign(r);
				r3.mul(10);
				r4.assign(plotX1);
				r4.div(r3);
				r4.floor();
				r4.mul(r3);
				//System.out.println("r2= nearest Y1"+r2.toString());
				while (r2.lessThan(plotX2)) {
					r2.add(r);
					x=g.getClipX()+getPlotX(r2,g.getClipWidth());
					while(r4.lessThan(r2)) r4.add(r3);
					if(r2.equalTo(r4)) yh=3;
					else yh=1;
					g.drawLine(x,g.getClipY()+y-yh,x,g.getClipY()+y+yh);
				}
			}
			//System.out.println("Noh tuli ny sitt tänne");
			if(plotfxcalc) {
				g.setColor(0x0000ff);			
				//System.out.println("Tulostaa fxcalcin");
				plotfncx(fxcalc,g);
			}
			if(plotgxcalc) {
				g.setColor(0xff0000);
				//System.out.println("noh plotgx");
				plotfncx(gxcalc,g);
			}
			/*if(plotfxycalc) {
				g.setColor(0xff0000);
				plotfncxytozero(fxycalc,g);
			}/**/
			plotfxcalc=false;
			//plotfxycalc=false;
			plotgxcalc=false;
			return;
		}
		if(statmode) {
			thirdbutton="data";
			((Calc[])(tablelist.elementAt(3)))[10]=calcn;
		} else ((Calc[])(tablelist.elementAt(3)))[10]=calcmode;

		g.setColor(0xffffff);
		g.fillRect(g.getClipX(),g.getClipY(),g.getClipWidth(),g.getClipHeight());
		g.setColor(0);
		//System.out.println("paint");
		if(cursor!=null) yh=cursor.getHeight(g)+2;
		if(calculations!=null) {
			idx=calculations;
			yh=0;
			x=0;
			while(idx!=null) {
				//System.out.println(idx.toString());
				//System.out.print("x=");
				//System.out.println(x);
				if(x+2+idx.getWidth(g)>g.getClipWidth()) {
					x=0;
					y+=yh;
					yh=idx.getHeight(g);
				}
				if(idx.getHeight(g)>yh) yh=idx.getHeight(g);
				idx.draw(g,g.getClipX()+2+x, g.getClipY()+y+1);
				x+=idx.getWidth(g);
				idx=idx.nextCalc();
			}
			//System.out.println("Tulosti calculationssin");
		}
		yh+=2;
		if(simplemode) {
			xw=g.getFont().stringWidth("x = /");
			y+=yh;
			g.drawString("+",2+xw/2,y,Graphics.TOP|Graphics.HCENTER);
			if(statmode) g.drawString("s="+statsum.toString(),x+5+xw,y,Graphics.TOP|Graphics.LEFT);
			yh=g.getFont().getHeight()+2;
			y+=yh;
			if(statmode) g.drawString("n="+statn.toString(),x+5+xw,y,Graphics.TOP|Graphics.LEFT);
			g.drawString("x = /",2+xw/2,y,Graphics.TOP|Graphics.HCENTER);
			y+=yh;
			if(statmode) g.drawString("otoskhajonta",x+5+xw,y,Graphics.TOP|Graphics.LEFT);
			g.drawString("-",2+xw/2,y,Graphics.TOP|Graphics.HCENTER);
		}
		for(int i=simplemode?9:0;i<12;i++) {
			if(i%3==0) {
				y+=yh;
				if(table[i]!=null) yh=table[i].getHeight(g);
				for(int j=1;j<3;j++) 
					if(table[i+j]!=null)
						if(yh<table[i+j].getHeight(g)) 
							yh=table[i+j].getHeight(g);
				yh+=1;
				x=0;
			}
			if(table[i%3]!=null) xw=table[i%3].getWidth(g);
			else xw=0;;
			for(int j=1;j<4;j++) {
				if(table[i%3+j*3]!=null) 
					if(xw<table[i%3+j*3].getWidth(g)) 
						xw=table[i%3+j*3].getWidth(g);
			}
			xw+=3;
			g.drawRect(x, y, xw, yh);
			if(table[i]!=null)
				table[i].draw(g,x+(xw-2-table[i].getWidth(g))/2+2,y);
			x+=xw;
			if(statmode) {
				if(i==2) g.drawString("s="+statsum.toString(),x+2,y,Graphics.TOP|Graphics.LEFT);
				else if(i==5) g.drawString("n="+statn.toString(),x+2,y,Graphics.TOP|Graphics.LEFT);
				else if(i==8) g.drawString("otoskhajonta",x+2,y,Graphics.TOP|Graphics.LEFT);
				else if(i==11) g.drawString(statvar.toString(),x+2,y,Graphics.TOP|Graphics.LEFT);
			}
		}
		y+=yh;
		if(statmode) if(errstr.equals("")) errstr="avg="+statavg.toString();
		x=0;
		//if(lastResult!=null) System.out.println("Result="+lastResult.toString());
		g.drawString(errstr/*(new Integer(keycode)).toString()*/,g.getClipX(),g.getClipY()+g.getClipHeight()-yh,Graphics.BOTTOM|Graphics.LEFT);
		g.drawString(firstbutton,g.getClipX(),g.getClipY()+g.getClipHeight(),Graphics.BOTTOM|Graphics.LEFT);
		g.drawString(firebutton,g.getClipX()+g.getClipWidth()/2,g.getClipY()+g.getClipHeight(),Graphics.BOTTOM|Graphics.HCENTER);
		g.drawString(thirdbutton,g.getClipX()+g.getClipWidth(),g.getClipY()+g.getClipHeight(),Graphics.BOTTOM|Graphics.RIGHT);
	}

	public void calculations(Calc tablex) {
		if(tablex!=null) {
			if(cursor!=null) cursor=tablex.addNextCalc(cursor);
			else {
				cursor=tablex.addFirstCalc(cursor);
				calculations=cursor;
			}
		}
	}

	public void setRealToCalculations(Real r) {
		Calc idx=calculations;
		int i=0;
		while (idx!=null) {
			i=i+1-idx.numOfParameters();
			//System.out.println(i);
			//System.out.println(idx.toString());
			idx=idx.nextCalc();
		}
		//System.out.println(i);
		if(cursor==null||i>0) {
			calculations=new CalcNumber(r,r.toString());
			cursor=calculations;
		} else if(cursor.numOfParameters()>0) {
			cursor=(new CalcNumber(r,r.toString())).addNextCalc(cursor);
		} else {
			calculations=new CalcNumber(r,r.toString());
			cursor=calculations;
		}
	}

	public void keyPressed(int keyCode) {
		short idxcursor=-1;
		int x;
		Calc idx;
		CalcTreeNode tree;
		Calc num;
		String s;
		//System.out.println(keyCode);
		//if(simplemode) table=(Calc[])(tablelist.elementAt(0));
		keycode=keyCode;
		if((( keyCode >= KEY_NUM0 ) && ( keyCode <= KEY_NUM9 ))||( keyCode == KEY_POUND ) || ( keyCode == KEY_STAR )) {
			if(keyCode == KEY_NUM0) x=10;
			else if(keyCode == KEY_STAR) x=9; 
			else if(keyCode == KEY_POUND) x=11;
			else x=keyCode-KEY_NUM1; 
			if(table[x].toString().equals("C/all")) {
				if(prevcALL) {
					calculations=null;
					cursor=null;
				} else {
					prevcALL=true;
					if(calculations!=null) {
						cursor=calculations.delete(cursor);
						if(cursor==null) calculations=null;
					}
				}
			} else {
				prevcALL=false;
				if(table[x]!=null) {
					idx=table[x];
					s=idx.toString();
					if(s.equals("mode")) {
						plotfxcalc=true;
						plotgxcalc=true;
						//plotfxycalc=true;
					} else if(s.equals("stofX")) {
						fxcalc.assignCalc(calculations);
						calculations=null;
						cursor=null;
					} else if(s.equals("stofXY")) {
						fxycalc.assignCalc(calculations);
						calculations=null;
						cursor=null;
					} else if(s.equals("stogX")) {
						gxcalc.assignCalc(calculations);
						calculations=null;
						cursor=null;
					} else if(s.equals("stoX")) {
						if(cursor.eval(null)!=null) xcalc.assignr(cursor.eval(null));
					} else if(s.equals("stoY")) {
						if(cursor.eval(null)!=null) ycalc.assignr(cursor.eval(null));
					} else if(s.equals("stoZ")) {
						if(cursor.eval(null)!=null) zcalc.assignr(cursor.eval(null));
					} else if(s.equals("avg")) {
						setRealToCalculations(statavg);
					} else if(s.equals("haj.")) {
						setRealToCalculations(statvar);
					} else if(s.equals("sum")) {
						setRealToCalculations(statsum);
					} else if(s.equals("n")) {
						setRealToCalculations(statn);
					} else if(s.equals("attrb")) {
						table=(Calc[])(tablelist.elementAt(4));
					} else 	{
						calculations(table[x]);
					}
				}
			}

		} else prevcALL=false;
		if((keyCode==UP)||(keyCode==-1)) {
			if(simplemode) calculations(calcadd);
			else table=(Calc[])(tablelist.elementAt(1));
		}
		if((keyCode==DOWN)||(keyCode==-2)) {
			if(simplemode) calculations(calcsub);
			else table=(Calc[])(tablelist.elementAt(0));
		}
		if(keyCode==-3) {
			if(simplemode) calculations(calcmul);
			else table=(Calc[])(tablelist.elementAt(2));
		}
		if(keyCode==-4) {
			if(simplemode) calculations(calcdiv);
			else table=(Calc[])(tablelist.elementAt(3));
		}
		errstr="";
		if(keyCode==-5) {
			if(calculations!=null) error=calculations.nextCalc();
			else error=null;
			//System.out.println("=");
			tree=null;
			try {
				tree=new CalcTreeNode(null,null,calculations.getNewObject());
				while((error!=null)&&(tree!=null)) {
					tree=tree.addCalcToTree(error.getNewObject());
					error=error.nextCalc();
				}
				if(tree!=null) {
					error=null;
					lastResult=tree.wholeTreeEval();
				}
			} catch (Exception e) {
				calculations=null;
				cursor=null;
			}
			if(tree==null) {
				calculations=null;
				cursor=null;
				errstr="Error";
				//System.out.println("tree==null");
				
			}
			else if((error==null)&&(lastResult!=null)) {
				//System.out.println("result="+lastResult);
				setRealToCalculations(lastResult);
				calculations=cursor;
			} else {
				cursor=null;
				calculations=null;
				errstr="Error";
			}
		}
		if(keyCode==-6) {
			if(firstbutton.equals("exit")) commandlistener.commandAction(exitCommand, null);
			else simplemode=!simplemode;
			//firstbutton="exit";
		} 
		if(simplemode) firstbutton="fnkMode";
		else firstbutton="smlmode";
		if(keyCode==-7) {
			x=0;
			if(thirdbutton.equals(")")) {
				x=0;
				idx=calculations;
				while(idx!=null) {
					if(idx.toString().equals("(")) x++;
					if(idx.toString().equals(")")) x--;
					idx=idx.nextCalc();
				}
				if(x>0) calculations(closeParenthese);
			}
			if(thirdbutton.equals("data")) {
				try {
					r.assign(((CalcNumber)(cursor)).getReal());
					statsum.add(r);
					
/*	Real statavg=new Real(0);
	Real statvar=new Real(0);
	Real statn=new Real(0);
	Real statx2=new Real(0);
	Real statsum=new Real(0);
	Real statsum2=new Real(0);
		table[9]=new CalcMode("C/all");
		table[10]=new CalcMode("avg");
		table[11]=new CalcMode("var");
		table[9]=new CalcMode("sum");
		table[10]=new CalcMode("n");
		table[11]=new CalcMode("attrb");
			
*/				
					statn.add(1);
					statavg.assign(statsum);
					statavg.div(statn);
					r.mul(((CalcNumber)(cursor)).getReal());
					statsum2.add(r);
// Calculations for variance
					r.assign(2);
					r.mul(statsum);
					r.mul(statavg);
					statvar.assign(statsum2);
					statvar.sub(r);

					r.assign(statavg);
					r.mul(statavg);
					r.mul(statn);

					statvar.add(r);

					r.assign(statn);
					r.sub(1);

					statvar.div(r);
					statvar.sqrt();
					cursor=calculations.delete(cursor);
					if(cursor==null) calculations=null;
				} catch (Exception e) {;
				}
			} else if(x<=0 || thirdbutton.equals("undo")) {
				if(calculations!=null) {
					cursor=calculations.delete(cursor);
					if(cursor==null) calculations=null;
				}
			}
		}






// End section
		if(simplemode) {
			table=(Calc[])tablelist.elementAt(0);
			thirdbutton=")";
		} else thirdbutton="undo";
		if(table==(Calc[])tablelist.elementAt(0)) {
			try {
				num=(CalcNumber)cursor;
				table[11]=plusminus;
			} catch (Exception e) {
				table[11]=openParenthese;
			}
			if(cursor==null) table[11]=openParenthese;
		}

		repaint();

	}
}
