/* Copyright (C) Sami Ojanen 2008 */
import javax.microedition.rms.RecordStore;

public class MyStore extends Object {

	private RecordStore myRS;

	public MyStore() {
		;
	}

	public static byte signedOrUnsignedByteToArray(short b,byte[] ba,int offset) {
		if ((b>255)||(b<-128)) return 0;
		if (b>127) {
			b=(short)(b-256);
		}
		ba[offset]=(byte)b;
		return 1;
	}
	public static short unsignedByteToShort(byte b) {
		if(b<0) {
			b++;
			return (short)((short)255+(short)b);
		}
		return (short)b;
	}

	public static short twoBytesToShort(byte[] ba, int offset) {
		short b1=0;
		short b2=0;
		byte minus=0;
		if(ba.length>=offset) b1=unsignedByteToShort(ba[offset]);
		offset++;
		if(ba.length>=offset) b2=unsignedByteToShort(ba[offset]);
		if(b2>=128) {
			b1=(short)(b1-255);
			b2=(short)(b2-255);
			return (short)(b1+256*b2-1);
		} else return (short)(256*b2+b1);
		
	}

	public static int fourBytesToInt(byte[] ba, int offset) {
		int b1=0;
		int b2=0;
		int b3=0;
		int b4=0; 
		if(ba.length>=offset) b1=(int)unsignedByteToShort(ba[offset]);
		offset++;
		if(ba.length>=offset) b2=(int)unsignedByteToShort(ba[offset]);
		offset++;
		if(ba.length>=offset) b3=(int)unsignedByteToShort(ba[offset]);
		offset++;
		if(ba.length>=offset) b4=(int)unsignedByteToShort(ba[offset]);
		if(b4>=128) {
			b1=b1-255;
			b2=b2-255;
			b3=b3-255;
			b4=b4-255;
			return 256*256*256*b4+256*256*b3+256*b2+b1-1;
		} else return 256*256*256*b4+256*256*b3+256*b2+b1;
	}

	public static long eightBytesToLong(byte[] ba, int offset) {
		long b1=0;
		long b2=0;
		long b3=0;
		long b4=0; 
		long b5=0;
		long b6=0;
		long b7=0;
		long b8=0; 
		if(ba.length>=offset) b1=(long)unsignedByteToShort(ba[offset]);
		offset++;
		if(ba.length>=offset) b2=(long)unsignedByteToShort(ba[offset]);
		offset++;
		if(ba.length>=offset) b3=(long)unsignedByteToShort(ba[offset]);
		offset++;
		if(ba.length>=offset) b4=(long)unsignedByteToShort(ba[offset]);
		offset++;
		if(ba.length>=offset) b5=(long)unsignedByteToShort(ba[offset]);
		offset++;
		if(ba.length>=offset) b6=(long)unsignedByteToShort(ba[offset]);
		offset++;
		if(ba.length>=offset) b7=(long)unsignedByteToShort(ba[offset]);
		offset++;
		if(ba.length>=offset) b8=(long)unsignedByteToShort(ba[offset]);
		if(b8>=128) {
			System.out.println("Negatiivinen");
			b1=b1-255;
			b2=b2-255;
			b3=b3-255;
			b4=b4-255;
			b5=b5-255;
			b6=b6-255;
			b7=b7-255;
			b8=b8-255;
			return (long)((long)256*256*256*256*256*256*256*b8+
				(long)256*256*256*256*256*256*b7+
				(long)256*256*256*256*256*b6+
				(long)256*256*256*256*b5+
				(long)256*256*256*b4+(long)256*256*b3+(long)256*b2+(long)b1-(long)1);
		} else return (long)((long)256*256*256*256*256*256*256*b8+
				(long)256*256*256*256*256*256*b7+
				(long)256*256*256*256*256*b6+
				(long)256*256*256*256*b5+(long)256*256*256*b4+(long)256*256*b3+(long)256*b2+(long)b1);
	}

	public static void longToEightBytes(byte[] ba, int offset,long x) {
		short b=0;
		short minus=0;
		if (x<0) {
			x++;
			minus=128;
			x+=Long.MAX_VALUE;
		}
		for(b=0;b<8;b++) {
			signedOrUnsignedByteToArray((short)(x & 255),ba,offset+b);
			x/=256;
		}
		ba[offset+b-1]|=minus;
	}
}

