/* Copyright (C) Sami Ojanen 2008 */
import ral.Real;
import java.util.Vector;
public class CalcMonoOperator extends Calc {

	protected String operator=null;
	protected int evalpriority=2;

	public CalcMonoOperator(String s) {
		operator=s;
		//System.out.println(evalpriority);
		//System.out.println(operator);
	}

	public Calc getNewObject() {
		//System.out.println("BiOperator.getNewObject");
		CalcMonoOperator c = new CalcMonoOperator(operator);
		return (Calc)c;
	}

	public int getEvalPriority() {
		return evalpriority;
	}

	public int numOfParameters() {
		return 1;
	}

	public Real eval(Vector parameters) {
		Real r1;
		Real r2;
		if(parameters.size()!=1) return null;
		else {
			r1=(Real)parameters.elementAt(0);
			//System.out.println(operator);
			if(operator.equals("sin")) {
				r1.sin();
				return r1;
			}
			if(operator.equals("cos")) {
				r1.cos();
				return r1;
			}
			if(operator.equals("tan")) {
				r1.tan();
				return r1;
			}
			if(operator.equals("asin")) {
				r1.asin();
				return r1;
			}
			if(operator.equals("acos")) {
				r1.acos();
				return r1;
			}
			if(operator.equals("atan")) {
				r1.atan();
				return r1;
			}
			if(operator.equals("sinh")) {
				r1.sinh();
				return r1;
			}
			if(operator.equals("cosh")) {
				r1.cosh();
				return r1;
			}
			if(operator.equals("tanh")) {
				r1.tanh();
				return r1;
			}
			if(operator.equals("asinh")) {
				r1.asinh();
				return r1;
			}
			if(operator.equals("acosh")) {
				r1.acosh();
				return r1;
			}
			if(operator.equals("atanh")) {
				r1.atanh();
				return r1;
			}
			if(operator.equals("e^")) {
				r1.exp();
				return r1;
			}
			if(operator.equals("ln")) {
				r1.ln();
				return r1;
			}
			if(operator.equals("lg")) {
				if(r1.equalTo(1)) {
					r1.assign(0);
					return r1;
				}
				r1.ln();
				r2 = new Real(10);
				r2.ln();
				r1.div(r2);
				return r1;
			}
			if(operator.equals("l2g")) {
				if(r1.equalTo(1)) {
					r1.assign(0);
					return r1;
				}
				r1.ln();
				r2 = new Real(2);
				r2.ln();
				r1.div(r2);
				return r1;
			}
			if(operator.equals("10^")) {
				r2=r1;
				r1=new Real(10);
				r1.ln();
				r2.mul(r1);
				r2.exp();
				return r2;
			}
			if(operator.equals("2^")) {
				r2=r1;
				r1=new Real(2);
				r1.ln();
				r2.mul(r1);
				r2.exp();
				return r2;
			}
			if(operator.equals("1/")) {
				r2=new Real(1);
				r2.div(r1);
				return r2;
			}
			if(operator.equals("^2")) {
				r2=new Real(r1);
				r1.mul(r2);
				return r1;
			}
			if(operator.equals("sqrt")) {
				r1.sqrt();
				return r1;
			}
		}
		return null;
	}

	public String toString() {
		return operator;
//		if(rs.charAt(rs.length()-1)=='.') return r.toString()+'.';
//		else return r.toString();
	}
}

