/* Copyright (C) Sami Ojanen 2008 */
import ral.Real;
import java.util.Vector;
public class CalcParenthese extends Calc {

	protected String s=null;
	protected char cs=':';

	public CalcParenthese(char c) {
		if(c=='(') s="(";
		else if(c==')') s=")";
		cs=c;
	}

	public Calc getNewObject() {
		//System.out.println("Parenthese.getNewObject");
		CalcParenthese p = new CalcParenthese(cs);
		//System.out.println(p.s);
		//System.out.println(p.cs);
		
		return (Calc)p;
	}

	public int getEvalPriority() {
		return 1;
	}

	public int numOfParameters() {
		return 1;
	}

	public Real eval(Vector parameters) {
		if(parameters.size()==1) return (Real)parameters.elementAt(0);
		else return null;
	}

	public String toString() {
		return s;
	}
}

