/* Copyright Sami Ojanen 2008*/
import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;

// Generated class. Modify.
public final class JustAnotherCalculator extends MIDlet implements CommandListener {
    private final Command exitCommand;
    private final Command exit2Command;
    private final Command delstat;
    private final Command statmode;
    private final Command settingsCommand;
    private final Command okCommand;
	private JACanvas jacanvas;

    public JustAnotherCalculator() {
	// Constructor. Place your code here.   
        exitCommand = new Command("mode", Command.EXIT, 1);
	exit2Command = new Command("exit", Command.EXIT, 1);
	delstat= new Command("purge stat", Command.EXIT,1);
	statmode = new Command("stat on/off", Command.EXIT, 1);
 	settingsCommand = new Command(")/del", Command.BACK, 2); // or ITEM
        okCommand = new Command("=", Command.OK, 3);
	jacanvas=new JACanvas(exitCommand,settingsCommand,(CommandListener)this);
        Display.getDisplay(this).setCurrent(jacanvas);
        jacanvas.addCommand(exitCommand);
        jacanvas.addCommand(exit2Command);
	jacanvas.addCommand(delstat);
	jacanvas.addCommand(statmode);
	jacanvas.addCommand(settingsCommand);
	jacanvas.addCommand(okCommand);
        jacanvas.setCommandListener(this);
    }
    
    protected void startApp() {
        // Place your code here.
    }
    
    protected void pauseApp() {
        // Place your code here.
    }
    
    protected void destroyApp(boolean unconditional) {
        // Place your code here.
    }
    
    public void commandAction(Command c, Displayable d) {
        // Place your code here.
        if (c == exit2Command) {
            destroyApp(false);
            notifyDestroyed();
        } else {
		if(c==okCommand) jacanvas.keyPressed(-5);
		if(c==exitCommand) jacanvas.keyPressed(-6);
		if(c==settingsCommand) jacanvas.keyPressed(-7);
		if(c==delstat) {
			//jacanvas.statmode=true;
			jacanvas.purgestat();
			//jacanvas.repaint();
		}
		if(c==statmode) {
			jacanvas.statmode=!jacanvas.statmode;
			jacanvas.repaint();
		}
	}
    }
}
